import java.awt.*;
import java.awt.event.*;
import java.io.IOException;
import javax.swing.*;
import java.util.*;
public class DiceConsole extends JFrame implements ActionListener,KeyListener,ItemListener{
    private int actionEventLabel;
    private boolean enterPressed;
    private JPanel buttonPanel;
    private SudokuPanel boardPanel;
    private JButton quitButton;
    private JButton solveButton;
    private JButton clearButton;
    private JCheckBox forceBox;
    private JLabel creditLabel;
    private final int WINDOW_X = 144;
    private final int WINDOW_Y = 144;
    private SudokuBoard board;
    private JTable boardTable;
    public DiceConsole(){
        super();
        //Localized the board
        board = new SudokuBoard();
        //Button+Label declarations below
        quitButton = new JButton("Quit");
        quitButton.addActionListener(this);
        quitButton.setActionCommand("666");
        solveButton = new JButton("Solve");
        solveButton.addActionListener(this);
        solveButton.setActionCommand("1");
        clearButton = new JButton("Clear");
        clearButton.addActionListener(this);
        clearButton.setActionCommand("0");
        forceBox = new JCheckBox("Force");
        forceBox.addItemListener(this);
        creditLabel = new JLabel(" Version 0.8");
        //Pane/Panel declarations below
        BorderLayout border = new BorderLayout();
        setLayout(border);
        GridLayout buttonGrid = new GridLayout(0,2,2,2);//Grid defines the way the buttons are ordered
        Object[][] tableData = {{"","","","","","","","",""},{"","","","","","","","",""},{"","","","","","","","",""},{"","","","","","","","",""},{"","","","","","","","",""},{"","","","","","","","",""},{"","","","","","","","",""},{"","","","","","","","",""},{"","","","","","","","",""}};
        Object[] columnNames = {"","","","","","","","",""};
        boardTable = new JTable(tableData,columnNames);
        boardTable.setRowSelectionAllowed(false);
        boardTable.setPreferredSize(new Dimension(144,144));
        buttonPanel = new JPanel();
        buttonPanel.setLayout(buttonGrid);
        boardPanel = new SudokuPanel();
        boardPanel.setBackground(Color.RED);
        //consoleScroller.setAutoscrolls(true);
        //The stuff below comes second to last
        //It takes the objects made above and glues them together
        //add(mainPanel,BorderLayout.CENTER);
        add(boardPanel,BorderLayout.NORTH);
        add(buttonPanel,BorderLayout.SOUTH);
        boardPanel.add(boardTable);
        //boardPanel.drawing(0,0,100,100);
        buttonPanel.add(solveButton);
        buttonPanel.add(clearButton);
        buttonPanel.add(forceBox);
        buttonPanel.add(quitButton);
        //Housekeeping
        this.setTitle("Most Honorable Sudoku");
        //The below must come last
        //Like, serious
        pack();
        setVisible(true);
    }
    public void solveBoard(){
        board.diagnosticPrint("SOLVE INVOKED");
        board.readyLogic();
        board.write(boardTable);
        board.swingPrint(board.solve(),boardTable);
    }
    public void clearScreen(){
        board.diagnosticPrint("CLEAR INVOKED");
        for(int i = 0;i<9;i++){
            for(int j = 0;j<9;j++){
                boardTable.setValueAt("",i,j);
            }
        }
    }
    //Non-working 3x3 system
    /*public int[][] toMatrix(){
        Scanner tableScan;
        int[][] returnable = new int[9][9];//[column][row]
        for(int i=0;i<3;i++){
            for(int j = 0;j<3;j++){
                for(int k = 0;k<3;k++){
                    for(int l = 0;l<3;l++){
                        tableScan =  new Scanner(tables[i+(3*j)].getValueAt(l,k).toString());
                        if(tableScan.hasNextInt()){
                            returnable[3*i+k][3*j+l] = tableScan.nextInt();
                        }
                    }
                }
            }
        }
        return returnable;
    }
    public void setScreen(int[][] input){
        for(int i=0;i<3;i++){
            for(int j = 0;j<3;j++){
                for(int k = 0;k<3;k++){
                    for(int l = 0;l<3;l++){
                        tables[i+(3*j)].setValueAt(input[3*i+k][3*j+l],l,k);
                    }
                }
            }
        }
    }
    public void clearScreen(){
        for(int i=0;i<3;i++){
            for(int j = 0;j<3;j++){
                for(int k = 0;k<3;k++){
                    for(int l = 0;l<3;l++){
                        tables[i+(3*j)].setValueAt("",k,l);
                    }
                }
            }
        }
    }
    */
    public void keyReleased(KeyEvent ke){}
    public void keyTyped(KeyEvent ke){}
    public void keyPressed(KeyEvent ke){}
    public void actionPerformed(ActionEvent ae){
        Scanner actionEventScanner = new Scanner(ae.getActionCommand());
        actionEventLabel = actionEventScanner.nextInt();
        actionEventSwitch(actionEventLabel);
    }
    public void itemStateChanged(ItemEvent e){
        Object source = e.getItemSelectable();
        if(source == forceBox){
            if(e.getStateChange() == ItemEvent.SELECTED){
                board.diagnosticPrint("FORCE ENABLE INVOKED");
                board.setBruteForce(true);
            }
            else{
                board.diagnosticPrint("FORCE DISABLE INVOKED");
                board.setBruteForce(false);
            }
        }
    }
    private void actionEventSwitch(int actionEventTag){
        switch(actionEventTag){
            case 0:
            clearScreen();
            break;
            case 1:
            solveBoard();
            break;
            case 666:
            System.exit(1);
            break;
            default:
            break;
        }
    }
}